package {
	import flash.display.Sprite;
	import flash.events.MouseEvent;

	/**
	 * 各クラスの基底クラス
	 */
	public class Base extends Sprite {
		/** 定数の宣言  */
		private const LEFT:String = "left";
		private const CENTER:String = "center";
		private const RIGHT:String = "right";
		
		/** コンストラクタ  */
		public function Base() {
			// マウスダウン時のイベントハンドラ(mouseDownHandler)をイベントリスナーへ登録
			addEventListener( MouseEvent.MOUSE_DOWN, mouseDownHandler );
		}

		/** マウスダウンした位置を返すメソッド  */
		protected function positionCheck( x:Number, y:Number ):String {
			var result:String;
			
			// オブジェクトの幅を3で割る
			var w:Number = width / 3;

			if ( x < w ) {
				result = LEFT; // オブジェクトの左側をマウスダウンしていたらresultにLEFTをセット
			} else if ( x >= w && x < w * 2 ) {
				result = CENTER; // オブジェクトの中央をマウスダウンしていたらresultにCENTERをセット
			} else {
				result = RIGHT; // オブジェクトの右側をマウスダウンしていたらresultにRIGHTをセット
			}
			return result; // 結果を返す
		}

		/** マウスダウン時のイベントハンドラ */
		protected function mouseDownHandler( event:MouseEvent ):void {
			// マウスダウンした位置の取得
			var check:String = positionCheck( event.localX, event.localY );

			switch ( check ) {
				case LEFT:
					// マウスムーブ時のイベントハンドラ(leftMouseMoveHandler)をイベントリスナーへ登録
					stage.addEventListener( MouseEvent.MOUSE_MOVE, leftMouseMoveHandler );
				break;
				case CENTER:
					startDrag();
				break;
				case RIGHT:
					// マウスムーブ時のイベントハンドラ(rightMouseMoveHandler)をイベントリスナーへ登録
					stage.addEventListener( MouseEvent.MOUSE_MOVE, rightMouseMoveHandler );
				break;
			}

			// マウスアップ時のイベントハンドラ(mouseUpHandler)をイベントリスナーへ登録
			stage.addEventListener( MouseEvent.MOUSE_UP, mouseUpHandler );
		}


		/** オブジェクトの左側をマウスダウンした後のマウスムーブ時のイベントハンドラ */
		protected function leftMouseMoveHandler( event:MouseEvent ):void {
			rotation -= 0.5; // 半時計周りに回転
		}


		/** オブジェクトの右側をマウスダウンした後のマウスムーブ時のイベントハンドラ */
		protected function rightMouseMoveHandler( event:MouseEvent ):void 	{
			rotation += 0.5; // 時計周りに回転
		}

		/** マウスアップ時のイベントハンドラ */
		protected function mouseUpHandler( envet:MouseEvent ):void {
			stopDrag(); // ドラックの停止
			
			// イベントリスナーからイベントハンドラの削除
			stage.removeEventListener( MouseEvent.MOUSE_MOVE, leftMouseMoveHandler );
			stage.removeEventListener( MouseEvent.MOUSE_MOVE, rightMouseMoveHandler );
			stage.removeEventListener( MouseEvent.MOUSE_UP, mouseUpHandler );
		}
	}
}